//+------------------------------------------------------------------+
//|                                            Anchored momentum.mq4 |
//|                                                           mladen |
//|                                                                  |
//| developed by Rudy Stefenel                                       |
//| Technical analysis of Stoctks and Commodities (TASC)             |
//| february 1998 - article : "Anchored momentum"                    |
//+------------------------------------------------------------------+
#property copyright "mladen"
#property link      "mladenfx@gmail.com"

#property indicator_separate_window
#property indicator_buffers 4
#property indicator_color1  Green
#property indicator_color2  DimGray
#property indicator_color3  Olive
#property indicator_color4  Olive

#property indicator_width1  2
#property indicator_width2  2


//
//
//
//
//

#define typeGeneral    0
#define typeMost       1
#define typeGeneralEma 2
#define typeMostEma    3

//
//
//
//
//

extern int Mom.Period    = 10;
extern int EmaPeriod    =  7;
extern int SmaPeriod    =  7;
extern int AppliedPrice = PRICE_CLOSE;
extern double Deviation    =  1.5;
extern int    DevPeriod    =  10;
extern int    DevMaMode    =  0;
extern int MomentumType = typeGeneral;

extern string note_type    ="General0 Most1";
extern string ____         ="GeneralEma2 MostEma3";

extern string note_MomIndexGen= "i:MomPeriod-(SmaPeriod-1)/2";
extern string note_MomIndexMost= "sma:2*MomPeriod+1";

//
//
//
//
//

double Momentum[];
double Momentul[];
double Buffers[];
double Buffere[];
double Buffer1[];
double Buffer2[];
string shortname;
string indx;
int    MomPeriod;
//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
//
//
//
//
//

int init()
{
   IndicatorBuffers(6);
      SetIndexBuffer(0,Momentum); SetIndexLabel(0,"Momentum"); SetIndexStyle(0,DRAW_HISTOGRAM);
      SetIndexBuffer(1,Momentul); SetIndexLabel(1,NULL);
      SetIndexBuffer(4,Buffers);
      SetIndexBuffer(5,Buffere);
      SetIndexBuffer(2,Buffer1); SetIndexLabel(2,"StDev"); SetIndexStyle(2,DRAW_LINE);
      SetIndexBuffer(3,Buffer2); SetIndexLabel(3,NULL);    SetIndexStyle(3,DRAW_LINE);
      
      //
      //
      //
      //
      //
      MomPeriod = Mom.Period;
      
      MomPeriod = MathMax(SmaPeriod,MomPeriod);
      MomPeriod = MathMax(EmaPeriod,MomPeriod);
      MomentumType = MathMax(MathMin(MomentumType,3),0);
      string type;
      switch (MomentumType)
         {
            case typeGeneral :    type = "General";          break;
            case typeGeneralEma : type = "General with EMA("+EmaPeriod+")"; break;
            case typeMost :       type = "Most  ";             break;
            case typeMostEma :    type = "Most with EMA("+EmaPeriod+") ";
         }
      shortname= "Anc.Mom. "+type+" SMA ("+SmaPeriod+") Mom ("+Mom.Period+") ";
//      IndicatorShortName(shortname);

         for(int b=0;b<=indicator_buffers;b++) SetIndexDrawBegin (b,MomPeriod*3);


   return(0);
}
int deinit() { return(0); }



//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
//
//
//
//
//

int start()
{
   int counted_bars = IndicatorCounted();
   int i,limit;

   if(counted_bars<0) return(-1);
   if(counted_bars>0) counted_bars--;
           limit=Bars-counted_bars;
   
   //
   //
   //
   //
   //
   
   for(i = limit; i >= 0; i--)
   {
      double price = iMA(NULL,0,1,0,MODE_SMA,AppliedPrice,i);
      int    index;

      //
      //
      //
      //
      //
int indxGen = MomPeriod-(SmaPeriod-1)/2.00;
int indxMost=2.00*MomPeriod+1;
      
      switch (MomentumType)
         {
            case typeGeneral :
                  index       = i+(MomPeriod-((SmaPeriod-1)/2.00));
                  Buffers[i]  = iMA(NULL,0,SmaPeriod,0,MODE_SMA,AppliedPrice,i);
                  Momentum[i] = EMPTY_VALUE;
                  
                  if (Buffers[index] != 0)
                        Momentum[i] = 100.00 * (price / Buffers[index] - 1.00);
//int indxG= MomPeriod-(SmaPeriod-1)/2.00;
         indx  = "MomIndx: "+indxGen;

                        break;

                       
                  //
                  //
                  //
                  //
                  //
                                          
            case typeMost :                                    
                  Buffers[i]  = iMA(NULL,0,2.00*MomPeriod+1,0,MODE_SMA,AppliedPrice,i);
                  Momentum[i] = EMPTY_VALUE;
                 
                  if (Buffers[i] != 0)
                        Momentum[i] = 100.00 * (price / Buffers[i] - 1.00);
//int indx2=2.00*MomPeriod+1;
         indx  = ""+indxMost;
                  indx="MomIndx: "+indxMost;

                        break;

                  //
                  //
                  //
                  //
                  //
                  
            case typeGeneralEma :
                  index       = i+(MomPeriod-((SmaPeriod-1)/2.00));
                  Buffers[i]  = iMA(NULL,0,SmaPeriod,0,MODE_SMA,AppliedPrice,i);
                  Buffere[i]  = iMA(NULL,0,EmaPeriod,0,MODE_EMA,AppliedPrice,i);
                  Momentum[i] = EMPTY_VALUE;
//int indx1= MomPeriod-(SmaPeriod-1)/2.00;

                  indx  = "MomIndx: "+indxGen;
                  
                  if (Buffers[index] != 0)
                        Momentum[i] = 100.00 * (Buffere[i] / Buffers[index] - 1.00);
                        break;
                  //
                  //
                  //
                  //
                  //
                                          
            case typeMostEma :
                  Buffers[i]  = iMA(NULL,0,2.00*MomPeriod+1,0,MODE_SMA,AppliedPrice,i);
                  Buffere[i]  = iMA(NULL,0,EmaPeriod,0,MODE_EMA,AppliedPrice,i);
                  Momentum[i] = EMPTY_VALUE;
//int indx2=2.00*MomPeriod+1;

                  indx="MomIndx: "+indxMost;

                  if (Buffers[i] != 0)
                        Momentum[i] = 100.00 * (Buffere[i] / Buffers[i] - 1.00);
         }
         Momentul[i] = Momentum[i];

         IndicatorShortName(shortname+indx);


    }
      for(i = limit; i >= 0; i--)
   {
 
    
    double std=Deviation*iStdDevOnArray(Momentum,0,DevPeriod,0,DevMaMode,i);                 

            Buffer1[i]= std;
            Buffer2[i]=-std; 

   }
       
return(0);
}